This service will be undergoing maintenance at 00:00 UTC, 2016-09-28. It is expected to last about 1 hours
Bug 210141 - XenD HTTP service serializes all requests
XenD HTTP service serializes all requests
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: xen (Show other bugs)
5.0
All Linux
medium Severity medium
: ---
: ---
Assigned To: Daniel Berrange
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2006-10-10 09:07 EDT by Daniel Berrange
Modified: 2007-11-30 17:07 EST (History)
2 users (show)

See Also:
Fixed In Version: RHEA-2007-0635
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-11-07 12:06:46 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Daniel Berrange 2006-10-10 09:07:37 EDT
Description of problem:
Libvirt talks to XenD over its HTTP service. Unfortunately the HTTP service
implementation is single-threaded, so all incoming requests are serialized. This
may not sound so bad until you consider that the 'VM Create' operation can take
anywhere from 5- 60 seconds to complete. During this time no other requests to
XenD will even be started. This means that *all* other applications using
libvirt will be blocked / hang  until the create operation completes. 

Version-Release number of selected component (if applicable):
xen-3.0.2-44

How reproducible:
Frequently

Steps to Reproduce:
1. Make a long running request to XenD (eg, a VM Create operation)
2. Attempt to make another unrelated request (eg list domains) at the same time
3.
  
Actual results:
The list domains request isn't processed until the create operation finishes

Expected results:
The requests are processed in parallel

Additional info:
I posted a prototype patch upstream to make XenD multi-threaded

http://lists.xensource.com/archives/html/xen-devel/2006-10/msg00264.html
Comment 1 Brian Stein 2006-10-25 13:23:41 EDT
We'd like this as a Beta2 blocker, but this isn't required.
Comment 2 RHEL Product and Program Management 2006-10-25 13:25:13 EDT
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux release.  Product Management has requested further review
of this request by Red Hat Engineering.  This request is not yet committed for
inclusion in release.
Comment 5 Daniel Berrange 2006-10-26 11:54:41 EDT
It has been posted upstream twice now, but no feedback has been forthcoming yet.

http://lists.xensource.com/archives/html/xen-devel/2006-10/msg01176.html

Comment 8 Daniel Berrange 2007-03-27 12:26:38 EDT
Merged upstream in 12776:c287052a0a654a74153f176fbd8159cb1d75211b

http://xenbits.xensource.com/xen-unstable.hg?rev/c287052a0a65
Comment 10 Daniel Berrange 2007-06-15 20:28:50 EDT
This is built into xen-3.0.3-29.el5 in dist-5E-qu-candidate. To test try the
following:

 1. Create a guest VM with 1 GB of RAM
 2. Crete a second guest VM 'B'
 3. Open two console windows
 4. In one run  'virsh save [guest A] /var/lib/xen/test.save
 5. At the same time as this is running, also run 'virsh dumpxml [guest B]' many
times over.

Prior to thsi fix, step 4 would 'hang' until step 3 completed. With this fix,
you should be able to run  step 4 without seeing any hang.
Comment 13 errata-xmlrpc 2007-11-07 12:06:46 EST
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHEA-2007-0635.html

Note You need to log in before you can comment on or make changes to this bug.